## gemma 0.97+dfsg

=== Makefile ===
# Generic Makefile for GEMMA
#
# Supported platforms
#
#       Unix / Linux               	LNX (default)
#       Mac                        	MAC
#
# Compilation options
#       static compilation    		FORCE_STATIC
#
# Examples:
#
#    Make GEMMA on Linux without OPENBLAS support:
#
#      make WITH_OPENBLAS=
#
#    Disable debug info and checks (slightly faster release mode)
#
#      make DEBUG=
#
#    Force static compilation
#
#      make FORCE_STATIC=1
#
#    Run tests with
#
#      make check
#
#    Run quick (development) tests with
#
#      make fast-check
#
#    Run full (lengthy) tests with
#
#      make check-all
#
#    See also the INSTALL.md document in the source tree at
#
#      https://github.com/genetics-statistics/GEMMA/blob/master/INSTALL.md

GEMMA_VERSION = $(shell cat ./VERSION)

# Set this variable to either LNX or MAC
SYS                    = LNX # LNX|MAC (Linux is the default)
# Leave blank after "=" to disable; put "= 1" to enable
DIST_NAME              = gemma-$(GEMMA_VERSION)
DEBUG                  = 1                # DEBUG mode, set DEBUG=0 for a release
SHOW_COMPILER_WARNINGS =
WITH_OPENBLAS          = 1                # Without OpenBlas uses LAPACK
WITH_LAPACK            =                  # Force linking LAPACK (if OpenBlas lacks it)
WITH_GSLCBLAS          =                  # Force linking gslcblas (if OpenBlas lacks it)
OPENBLAS_LEGACY        =                  # Using older OpenBlas
FORCE_STATIC           =                  # Static linking of libraries
GCC_FLAGS              = -Wall -O3 -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
TRAVIS_CI              =                  # used by TRAVIS for testing
EIGEN_INCLUDE_PATH     = /usr/include/eigen3
OPENBLAS_INCLUDE_PATH  = /usr/local/opt/openblas/include

# --------------------------------------------------------------------
# Edit below this line with caution
# --------------------------------------------------------------------

BIN_DIR  = ./bin
SRC_DIR  = ./src
TEST_SRC_DIR  = ./test/src

ifdef CXX # CXX defined in environment
  CPP = $(CXX)
  CC = $(CXX)
else
  CPP = g++
endif

ifeq ($(CPP), clang++)
  # macOS Homebrew settings (as used on Travis-CI)
  GCC_FLAGS=-O3 -std=c++11 -stdlib=libc++ -isystem/$(OPENBLAS_INCLUDE_PATH) -isystem//usr/local/include/eigen3 -Wl,-L/usr/local/opt/openblas/lib
endif

ifdef WITH_OPENBLAS
  OPENBLAS=1
  # WITH_LAPACK =  # OPENBLAS usually includes LAPACK
  CPPFLAGS += -DOPENBLAS -isystem/$(OPENBLAS_INCLUDE_PATH)
  ifdef OPENBLAS_LEGACY
    # Legacy version (mostly for Travis-CI)
    CPPFLAGS += -DOPENBLAS_LEGACY
  endif
endif

ifdef DEBUG
  CPPFLAGS += -g $(GCC_FLAGS) -isystem/$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
else
  # release mode
  CPPFLAGS += -DNDEBUG $(GCC_FLAGS) -isystem/$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
endif

ifdef SHOW_COMPILER_WARNINGS
  CPPFLAGS += -Wall
endif

ifndef FORCE_STATIC
  LIBS = -lgsl -lopenblas -pthread -lz
  ifdef WITH_GSLCBLAS
    LIBS += -lgslcblas
  else
    LIBS += -lgfortran -lquadmath
  endif
else
  ifndef TRAVIS_CI # Travis static compile we cheat a little
    CPPFLAGS += -static
  endif
endif

.PHONY: all

OUTPUT = $(BIN_DIR)/gemma

# Detailed libary paths, D for dynamic and S for static

ifdef WITH_LAPACK
  LIBS_LNX_D_LAPACK = -llapack
endif
LIBS_MAC_D_LAPACK = -framework Accelerate
# LIBS_LNX_S_LAPACK = /usr/lib/libgsl.a  /usr/lib/libgslcblas.a /usr/lib/lapack/liblapack.a -lz
# LIBS_LNX_S_LAPACK = /usr/lib/lapack/liblapack.a -lgfortran  /usr/lib/atlas-base/libatlas.a /usr/lib/libblas/libblas.a -Wl,--allow-multiple-definition

ifdef WITH_LAPACK
  ifeq ($(SYS), MAC)
    LIBS += $(LIBS_MAC_D_LAPACK)
  else
    ifndef FORCE_STATIC
      ifdef WITH_OPENBLAS
        LIBS += -lopenblas
      else
        LIBS += $(LIBS_LNX_D_BLAS)
      endif
      LIBS += $(LIBS_LNX_D_LAPACK)
    else
      LIBS += $(LIBS_LNX_S_LAPACK)
    endif
  endif
endif

HDR          = $(wildcard src/*.h) ./src/version.h
SOURCES      = $(wildcard src/*.cpp)

# all
OBJS = $(SOURCES:.cpp=.o)

all: $(OUTPUT)

./src/version.h:
	./scripts/gen_version_info.sh > src/version.h

$(OUTPUT): $(OBJS)
	$(CPP) $(CPPFLAGS) $(OBJS) $(LIBS) -o $(OUTPUT)

$(OBJS): $(HDR)

.SUFFIXES : .cpp .c .o $(SUFFIXES)

./bin/unittests-gemma: contrib/catch-1.9.7/catch.hpp $(TEST_SRC_DIR)/unittests-main.o $(TEST_SRC_DIR)/unittests-math.o $(OBJS)
	$(CPP) $(CPPFLAGS) $(TEST_SRC_DIR)/unittests-main.o  $(TEST_SRC_DIR)/unittests-math.o $(filter-out src/main.o, $(OBJS)) $(LIBS) -o ./bin/unittests-gemma

unittests: ./bin/unittests-gemma
	./bin/unittests-gemma

fast-check: all unittests
	rm -vf test/output/*
	cd test && ./dev_test_suite.sh | tee ../dev_test.log
	grep -q 'success rate: 100%' dev_test.log

slow-check: all
	rm -vf test/output/*
	cd test && ./test_suite.sh | tee ../test.log
	grep -q 'success rate: 100%' test.log

lengthy-check: all
	rm -vf test/output/*
	cd test && ./lengthy_test_suite.sh | tee ../lengthy_test.log
	grep -q 'success rate: 100%' lengthy_test.log

check: fast-check slow-check

check-all: check lengthy-check

clean:
	rm $(SRC_DIR)/version.h
	rm -vf $(SRC_DIR)/*.o
	rm -vf $(SRC_DIR)/*~
	rm -vf $(TEST_SRC_DIR)/*.o
	rm -vf $(OUTPUT)
	rm -vf ./bin/unittests-gemma

DIST_COMMON = *.md LICENSE VERSION Makefile
DIST_SUBDIRS = src doc example bin

tar: version all
	@echo "Creating $(DIST_NAME)"
	mkdir -p ./$(DIST_NAME)
	cp $(DIST_COMMON) ./$(DIST_NAME)/
	cp -r $(DIST_SUBDIRS) ./$(DIST_NAME)/
	tar cvzf $(DIST_NAME).tar.gz ./$(DIST_NAME)/
	rm -r ./$(DIST_NAME)

=== debian/changelog ===
gemma (0.97+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Add autopkgtest.
  * Add patch for reproducible builds.

 -- Dylan Aïssi <bob.dybian@gmail.com>  Fri, 15 Jun 2018 21:46:35 +0200

gemma (0.97+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix VCS field.
  * Update watch file to mangle deb version.
  * Add libgsl-dev, zlib1g-dev and gfortran to Build-Depends (Closes: #900759).

 -- Dylan Aïssi <bob.dybian@gmail.com>  Thu, 07 Jun 2018 08:07:15 +0200

gemma (0.97+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #896980).

 -- Steffen Moeller <moeller@debian.org>  Wed, 25 Apr 2018 17:48:45 +0200

=== debian/control ===
Source: gemma
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               gfortran,
               libopenblas-dev,
               libeigen3-dev,
               libgsl-dev,
               zlib1g-dev,
               catch,
               shunit2
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/med-team/gemma
Vcs-Git: https://salsa.debian.org/med-team/gemma.git
Homepage: http://www.xzlab.org/software.html

Package: gemma
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Genome-wide Efficient Mixed Model Association
 GEMMA is the software implementing the Genome-wide Efficient Mixed
 Model Association algorithm for a standard linear mixed model and some
 of its close relatives for genome-wide association studies (GWAS):
 .
  * It fits a univariate linear mixed model (LMM) for marker association
    tests with a single phenotype to account for population stratification
    and sample structure, and for estimating the proportion of variance in
    phenotypes explained (PVE) by typed genotypes (i.e. "chip heritability").
  * It fits a multivariate linear mixed model (mvLMM) for testing marker
    associations with multiple phenotypes simultaneously while controlling
    for population stratification, and for estimating genetic correlations
    among complex phenotypes.
  * It fits a Bayesian sparse linear mixed model (BSLMM) using Markov
    chain Monte Carlo (MCMC) for estimating PVE by typed genotypes,
    predicting phenotypes, and identifying associated markers by jointly
    modeling all markers while controlling for population structure.
  * It estimates variance component/chip heritability, and partitions
    it by different SNP functional categories. In particular, it uses HE
    regression or REML AI algorithm to estimate variance components when
    individual-level data are available. It uses MQS to estimate variance
    components when only summary statisics are available.
 .
 GEMMA is computationally efficient for large scale GWAS and uses freely
 available open-source numerical libraries.

Package: gemma-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: gemma
Description: Example folder for GEMMA
 This package ships example data for the Genome-wide Efficient Mixed
 Model Association.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


override_dh_clean:
	dh_clean
	rm -f *.log
	rm -rf test/output/
	rm -f bin/gemma

## gemma 0.98+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,11 +2,12 @@
 #
 # Supported platforms
 #
-#       Unix / Linux               	LNX (default)
-#       Mac                        	MAC
+#       Unix / Linux               LNX (default)
+#       Mac                        MAC
+#       GNU Guix                   GUIX (set to profile)
 #
 # Compilation options
-#       static compilation    		FORCE_STATIC
+#       static compilation         FORCE_STATIC
 #
 # Examples:
 #
@@ -34,6 +35,10 @@
 #
 #      make check-all
 #
+#    To compile with CLANG
+#
+#      make CXX=clang++ check
+#
 #    See also the INSTALL.md document in the source tree at
 #
 #      https://github.com/genetics-statistics/GEMMA/blob/master/INSTALL.md
@@ -41,20 +46,59 @@
 GEMMA_VERSION = $(shell cat ./VERSION)
 
 # Set this variable to either LNX or MAC
-SYS                    = LNX # LNX|MAC (Linux is the default)
+ifeq ($(OS),Windows_NT)
+  SYS = WIN
+  VGEN = scripts/gen_version_info.cmd
+else
+  UNAME_S := $(shell uname -s)
+  ifeq ($(UNAME_S),Darwin)
+    SYS = MAC
+  else
+    SYS = LNX # default to linux
+  endif
+  VGEN = scripts/gen_version_info.sh
+endif
+
 # Leave blank after "=" to disable; put "= 1" to enable
 DIST_NAME              = gemma-$(GEMMA_VERSION)
 DEBUG                  = 1                # DEBUG mode, set DEBUG=0 for a release
+PROFILING              =                  # Add profiling info
 SHOW_COMPILER_WARNINGS =
 WITH_OPENBLAS          = 1                # Without OpenBlas uses LAPACK
+WITH_ATLAS             =                  # In place of OpenBlas(?)
 WITH_LAPACK            =                  # Force linking LAPACK (if OpenBlas lacks it)
 WITH_GSLCBLAS          =                  # Force linking gslcblas (if OpenBlas lacks it)
 OPENBLAS_LEGACY        =                  # Using older OpenBlas
 FORCE_STATIC           =                  # Static linking of libraries
-GCC_FLAGS              = -Wall -O3 -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
+# GCC_FLAGS              = -Wall -O3 -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
+GCC_FLAGS              = -DHAVE_INLINE -pthread -Wall -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
 TRAVIS_CI              =                  # used by TRAVIS for testing
-EIGEN_INCLUDE_PATH     = /usr/include/eigen3
-OPENBLAS_INCLUDE_PATH  = /usr/local/opt/openblas/include
+
+GSL_INCLUDE_PATH =
+ifeq ($(SYS), WIN)
+  GSL_INCLUDE_PATH = -isystemc:/MinGW/include -LC:/MinGW/lib
+  EIGEN_INCLUDE_PATH = ../eigen-git-mirror
+  OPENBLAS_INCLUDE_PATH = ../OpenBLAS-v0.2.19-Win64-int32/include -L../OpenBLAS-v0.2.19-Win64-int32/lib
+else
+  OPENBLAS_INCLUDE_PATH = /usr/local/opt/openblas/include
+  ifeq ($(SYS), MAC)
+    EIGEN_INCLUDE_PATH = /usr/local/include/eigen3
+  else
+    EIGEN_INCLUDE_PATH = /usr/include/eigen3
+  endif
+  ifndef GUIX
+    ifdef GUIX_ENVIRONMENT
+      GUIX=$(GUIX_ENVIRONMENT)
+    endif
+  endif
+  ifdef GUIX
+    # Effectively disable paths for GNU Guix
+    OPENBLAS_INCLUDE_PATH = .
+    EIGEN_INCLUDE_PATH = $(GUIX)/include/eigen3
+    # RPATH = -Xlinker --rpath=$(GUIX)/lib
+    GUIX_PROFILE =$(realpath $(GUIX))
+  endif
+endif
 
 # --------------------------------------------------------------------
 # Edit below this line with caution
@@ -73,24 +117,45 @@
 
 ifeq ($(CPP), clang++)
   # macOS Homebrew settings (as used on Travis-CI)
-  GCC_FLAGS=-O3 -std=c++11 -stdlib=libc++ -isystem/$(OPENBLAS_INCLUDE_PATH) -isystem//usr/local/include/eigen3 -Wl,-L/usr/local/opt/openblas/lib
+  # GCC_FLAGS=-O3 -std=c++11 -stdlib=libc++ -isystem$(OPENBLAS_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Wl,-L/usr/local/opt/openblas/lib
+  GCC_FLAGS=-std=c++11 -isystem$(OPENBLAS_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH)
 endif
 
 ifdef WITH_OPENBLAS
   OPENBLAS=1
   # WITH_LAPACK =  # OPENBLAS usually includes LAPACK
-  CPPFLAGS += -DOPENBLAS -isystem/$(OPENBLAS_INCLUDE_PATH)
+  CPPFLAGS += -DOPENBLAS -isystem$(OPENBLAS_INCLUDE_PATH)
   ifdef OPENBLAS_LEGACY
     # Legacy version (mostly for Travis-CI)
     CPPFLAGS += -DOPENBLAS_LEGACY
   endif
+else
+  ifdef WITH_ATLAS
+    CPPFLAGS += -DUSE_BLAS=atlas
+  endif
+endif
+
+ifeq ($(CXX), clang++)
+  # CPPFLAGS += -isystem$(GUIX)/include/c++ -isystem$(GUIX)/include/c++/x86_64-unknown-linux-gnu
+  ifdef GUIX
+    CPPFLAGS += -I$(GUIX)/include/c++ -I$(GUIX)/include/c++/x86_64-unknown-linux-gnu
+  endif
+  # -L$(GUIX)/lib
 endif
 
 ifdef DEBUG
-  CPPFLAGS += -g $(GCC_FLAGS) -isystem/$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+  CPPFLAGS += -g -Og $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc $(RPATH)
 else
   # release mode
-  CPPFLAGS += -DNDEBUG $(GCC_FLAGS) -isystem/$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+  CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc $(RPATH)
+endif
+
+ifdef PROFILING
+  CPPFLAGS += -pg
+endif
+
+ifeq ($(SYS), WIN)
+  CPPFLAGS += -Duint="unsigned int" -D__CRT__NO_INLINE -D__STRING="__STRINGIFY" -DWINDOWS -DWITH_GSLCBLAS=1
 endif
 
 ifdef SHOW_COMPILER_WARNINGS
@@ -98,17 +163,24 @@
 endif
 
 ifndef FORCE_STATIC
-  LIBS = -lgsl -lopenblas -pthread -lz
+  LIBS = -lgsl -lz
+  ifdef WITH_OPENBLAS
+    LIBS += -lopenblas
+  else
+    LIBS += -L$(GUIX_ENVIRONMENT) -latlas -lcblas -llapack -lblas
+  endif
   ifdef WITH_GSLCBLAS
     LIBS += -lgslcblas
   else
     LIBS += -lgfortran -lquadmath
   endif
 else
+  LIBS = -L$(GUIX)/lib -lopenblas -lgsl -lz -lgslcblas -lgfortran -lquadmath
   ifndef TRAVIS_CI # Travis static compile we cheat a little
     CPPFLAGS += -static
   endif
 endif
+
 
 .PHONY: all
 
@@ -126,6 +198,9 @@
 ifdef WITH_LAPACK
   ifeq ($(SYS), MAC)
     LIBS += $(LIBS_MAC_D_LAPACK)
+    ifdef WITH_OPENBLAS
+      LIBS += -Wl,-L/usr/local/opt/openblas/lib
+    endif
   else
     ifndef FORCE_STATIC
       ifdef WITH_OPENBLAS
@@ -148,8 +223,8 @@
 
 all: $(OUTPUT)
 
-./src/version.h:
-	./scripts/gen_version_info.sh > src/version.h
+./src/version.h: ./VERSION
+	$(shell bash $(VGEN) $(GUIX_PROFILE) > src/version.h)
 
 $(OUTPUT): $(OBJS)
 	$(CPP) $(CPPFLAGS) $(OBJS) $(LIBS) -o $(OUTPUT)
@@ -161,7 +236,7 @@
 ./bin/unittests-gemma: contrib/catch-1.9.7/catch.hpp $(TEST_SRC_DIR)/unittests-main.o $(TEST_SRC_DIR)/unittests-math.o $(OBJS)
 	$(CPP) $(CPPFLAGS) $(TEST_SRC_DIR)/unittests-main.o  $(TEST_SRC_DIR)/unittests-math.o $(filter-out src/main.o, $(OBJS)) $(LIBS) -o ./bin/unittests-gemma
 
-unittests: ./bin/unittests-gemma
+unittests: all ./bin/unittests-gemma
 	./bin/unittests-gemma
 
 fast-check: all unittests
@@ -184,7 +259,6 @@
 check-all: check lengthy-check
 
 clean:
-	rm $(SRC_DIR)/version.h
 	rm -vf $(SRC_DIR)/*.o
 	rm -vf $(SRC_DIR)/*~
 	rm -vf $(TEST_SRC_DIR)/*.o

=== debian/changelog ===
gemma (0.98+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix folder of examples files in autopkgtest (Closes: #907406)
  * Set Multi-Arch: foreign for gemma-doc

 -- Dylan Aïssi <daissi@debian.org>  Mon, 22 Oct 2018 07:32:31 +0200

gemma (0.98+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix section of doc package

  [ Steffen Moeller ]
  * New upstream release

 -- Steffen Moeller <moeller@debian.org>  Sun, 14 Oct 2018 19:34:47 +0200

gemma (0.97+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Don't link with libquadmath (Thanks for the patch to Adrian Bunk
    <bunk@debian.org>)
    Closes: #902153
  * No parallel test
    Closes: #904854
  * Fix installation of docs
  * debhelper 11
  * Standards-Version: 4.2.0

 -- Andreas Tille <tille@debian.org>  Sun, 26 Aug 2018 17:00:21 +0200

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gemma-$1.tar.gz% ,repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g" \
   https://github.com/genetics-statistics/gemma/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## gemma 0.98.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Supported platforms
 #
 #       Unix / Linux               LNX (default)
-#       Mac                        MAC
+#       Mac                        OSX
 #       GNU Guix                   GUIX (set to profile)
 #
 # Compilation options
@@ -15,13 +15,13 @@
 #
 #      make WITH_OPENBLAS=
 #
-#    Disable debug info and checks (slightly faster release mode)
-#
-#      make DEBUG=
+#    Disable debug info and checks (release mode is slightly faster)
+#
+#      make debug
 #
 #    Force static compilation
 #
-#      make FORCE_STATIC=1
+#      make static
 #
 #    Run tests with
 #
@@ -37,7 +37,7 @@
 #
 #    To compile with CLANG
 #
-#      make CXX=clang++ check
+#      make CXX=clang++
 #
 #    See also the INSTALL.md document in the source tree at
 #
@@ -45,14 +45,14 @@
 
 GEMMA_VERSION = $(shell cat ./VERSION)
 
-# Set this variable to either LNX or MAC
+# Set this variable to either LNX or OSX
 ifeq ($(OS),Windows_NT)
   SYS = WIN
   VGEN = scripts/gen_version_info.cmd
 else
   UNAME_S := $(shell uname -s)
   ifeq ($(UNAME_S),Darwin)
-    SYS = MAC
+    SYS = OSX
   else
     SYS = LNX # default to linux
   endif
@@ -68,11 +68,10 @@
 WITH_ATLAS             =                  # In place of OpenBlas(?)
 WITH_LAPACK            =                  # Force linking LAPACK (if OpenBlas lacks it)
 WITH_GSLCBLAS          =                  # Force linking gslcblas (if OpenBlas lacks it)
+WITH_GFORTRAN          =                  # Add -lgfortran (if OpenBlas does not pull it in)
 OPENBLAS_LEGACY        =                  # Using older OpenBlas
 FORCE_STATIC           =                  # Static linking of libraries
-# GCC_FLAGS              = -Wall -O3 -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
 GCC_FLAGS              = -DHAVE_INLINE -pthread -Wall -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
-TRAVIS_CI              =                  # used by TRAVIS for testing
 
 GSL_INCLUDE_PATH =
 ifeq ($(SYS), WIN)
@@ -81,7 +80,7 @@
   OPENBLAS_INCLUDE_PATH = ../OpenBLAS-v0.2.19-Win64-int32/include -L../OpenBLAS-v0.2.19-Win64-int32/lib
 else
   OPENBLAS_INCLUDE_PATH = /usr/local/opt/openblas/include
-  ifeq ($(SYS), MAC)
+  ifeq ($(SYS), OSX)
     EIGEN_INCLUDE_PATH = /usr/local/include/eigen3
   else
     EIGEN_INCLUDE_PATH = /usr/include/eigen3
@@ -96,6 +95,9 @@
     OPENBLAS_INCLUDE_PATH = .
     EIGEN_INCLUDE_PATH = $(GUIX)/include/eigen3
     # RPATH = -Xlinker --rpath=$(GUIX)/lib
+    ifdef FORCE_STATIC
+      LIBS = -L$(GUIX)/lib
+    endif
     GUIX_PROFILE =$(realpath $(GUIX))
   endif
 endif
@@ -116,9 +118,10 @@
 endif
 
 ifeq ($(CPP), clang++)
-  # macOS Homebrew settings (as used on Travis-CI)
-  # GCC_FLAGS=-O3 -std=c++11 -stdlib=libc++ -isystem$(OPENBLAS_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Wl,-L/usr/local/opt/openblas/lib
   GCC_FLAGS=-std=c++11 -isystem$(OPENBLAS_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH)
+  ifdef GUIX
+    CPPFLAGS += -I$(GUIX)/include/c++ -I$(GUIX)/include/c++/x86_64-unknown-linux-gnu
+  endif
 endif
 
 ifdef WITH_OPENBLAS
@@ -135,24 +138,19 @@
   endif
 endif
 
-ifeq ($(CXX), clang++)
-  # CPPFLAGS += -isystem$(GUIX)/include/c++ -isystem$(GUIX)/include/c++/x86_64-unknown-linux-gnu
-  ifdef GUIX
-    CPPFLAGS += -I$(GUIX)/include/c++ -I$(GUIX)/include/c++/x86_64-unknown-linux-gnu
-  endif
-  # -L$(GUIX)/lib
-endif
-
-ifdef DEBUG
-  CPPFLAGS += -g -Og $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc $(RPATH)
-else
-  # release mode
-  CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc $(RPATH)
-endif
-
-ifdef PROFILING
-  CPPFLAGS += -pg
-endif
+ifneq ($(CXX), clang++)
+  # Clang does not like this switch
+  debug check fast-check: CPPFLAGS += -Og
+endif
+
+debug check fast-check: CPPFLAGS += -g $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+
+profile: CPPFLAGS += -pg
+
+release: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+
+static: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+
 
 ifeq ($(SYS), WIN)
   CPPFLAGS += -Duint="unsigned int" -D__CRT__NO_INLINE -D__STRING="__STRINGIFY" -DWINDOWS -DWITH_GSLCBLAS=1
@@ -162,56 +160,38 @@
   CPPFLAGS += -Wall
 endif
 
-ifndef FORCE_STATIC
-  LIBS = -lgsl -lz
-  ifdef WITH_OPENBLAS
-    LIBS += -lopenblas
-  else
-    LIBS += -L$(GUIX_ENVIRONMENT) -latlas -lcblas -llapack -lblas
-  endif
-  ifdef WITH_GSLCBLAS
-    LIBS += -lgslcblas
-  else
-    LIBS += -lgfortran -lquadmath
-  endif
-else
-  LIBS = -L$(GUIX)/lib -lopenblas -lgsl -lz -lgslcblas -lgfortran -lquadmath
-  ifndef TRAVIS_CI # Travis static compile we cheat a little
-    CPPFLAGS += -static
-  endif
-endif
-
-
-.PHONY: all
+static: CPPFLAGS += -static
+
+LIBS += -lgsl -lz
+ifdef WITH_OPENBLAS
+  LIBS += -lopenblas
+else
+  LIBS += -latlas -lcblas -llapack -lblas
+endif
+ifdef WITH_GSLCBLAS
+  LIBS += -lgslcblas
+endif
+ifdef WITH_GFORTRAN
+  LIBS += -lgfortran -lquadmath
+endif
+
+.PHONY: all test
 
 OUTPUT = $(BIN_DIR)/gemma
 
 # Detailed libary paths, D for dynamic and S for static
 
 ifdef WITH_LAPACK
-  LIBS_LNX_D_LAPACK = -llapack
-endif
-LIBS_MAC_D_LAPACK = -framework Accelerate
-# LIBS_LNX_S_LAPACK = /usr/lib/libgsl.a  /usr/lib/libgslcblas.a /usr/lib/lapack/liblapack.a -lz
-# LIBS_LNX_S_LAPACK = /usr/lib/lapack/liblapack.a -lgfortran  /usr/lib/atlas-base/libatlas.a /usr/lib/libblas/libblas.a -Wl,--allow-multiple-definition
+  LIBS += -llapack
+endif
+LIBS_OSX_D_LAPACK = -framework Accelerate
 
 ifdef WITH_LAPACK
-  ifeq ($(SYS), MAC)
-    LIBS += $(LIBS_MAC_D_LAPACK)
+  ifeq ($(SYS), OSX)
+    LIBS += $(LIBS_OSX_D_LAPACK)
     ifdef WITH_OPENBLAS
       LIBS += -Wl,-L/usr/local/opt/openblas/lib
     endif
-  else
-    ifndef FORCE_STATIC
-      ifdef WITH_OPENBLAS
-        LIBS += -lopenblas
-      else
-        LIBS += $(LIBS_LNX_D_BLAS)
-      endif
-      LIBS += $(LIBS_LNX_D_LAPACK)
-    else
-      LIBS += $(LIBS_LNX_S_LAPACK)
-    endif
   endif
 endif
 
@@ -221,7 +201,13 @@
 # all
 OBJS = $(SOURCES:.cpp=.o)
 
-all: $(OUTPUT)
+all: release
+
+release: $(OUTPUT)
+
+static: $(OUTPUT)
+
+debug: $(OUTPUT)
 
 ./src/version.h: ./VERSION
 	$(shell bash $(VGEN) $(GUIX_PROFILE) > src/version.h)

=== debian/changelog ===
gemma (0.98.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Simplify watch file

 -- Andreas Tille <tille@debian.org>  Tue, 18 Dec 2018 16:16:05 +0100

gemma (0.98+dfsg-3) unstable; urgency=medium

  * Team upload
  * Allow output to stderr in autopkgtests

 -- Graham Inggs <ginggs@debian.org>  Tue, 13 Nov 2018 13:33:54 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Steffen Moeller <moeller@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11~),
                gfortran,
                libopenblas-dev,
                libeigen3-dev,
@@ -11,7 +11,7 @@
                zlib1g-dev,
                catch,
                shunit2
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/med-team/gemma
 Vcs-Git: https://salsa.debian.org/med-team/gemma.git
 Homepage: http://www.xzlab.org/software.html
@@ -48,6 +48,8 @@
 
 Package: gemma-doc
 Architecture: all
+Multi-Arch: foreign
+Section: doc
 Depends: ${misc:Depends}
 Recommends: gemma
 Description: Example folder for GEMMA

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/catch -I/usr/include/eigen
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/catch -I/usr/include/eigen
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_clean:
	dh_clean
	rm -f *.log
	rm -rf test/output/
	rm -f bin/gemma

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel
endif

## gemma 0.98.4%2Bdfsg

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,10 @@
 #    Force static compilation
 #
 #      make static
+#
+#    Static build may require some extra flags
+#
+#      make WITH_GFORTRAN=1 EXTRA_FLAGS=-L/gnu/store/741057r2x06zwg6zcmqmdyv51spm6n9i-gfortran-7.5.0-lib/lib static
 #
 #    Run tests with
 #
@@ -72,19 +76,14 @@
 OPENBLAS_LEGACY        =                  # Using older OpenBlas
 FORCE_STATIC           =                  # Static linking of libraries
 GCC_FLAGS              = -DHAVE_INLINE -pthread -Wall -std=gnu++11 # extra flags -Wl,--allow-multiple-definition
+EXTRA_FLAGS            =
 
 GSL_INCLUDE_PATH =
 ifeq ($(SYS), WIN)
   GSL_INCLUDE_PATH = -isystemc:/MinGW/include -LC:/MinGW/lib
-  EIGEN_INCLUDE_PATH = ../eigen-git-mirror
   OPENBLAS_INCLUDE_PATH = ../OpenBLAS-v0.2.19-Win64-int32/include -L../OpenBLAS-v0.2.19-Win64-int32/lib
 else
   OPENBLAS_INCLUDE_PATH = /usr/local/opt/openblas/include
-  ifeq ($(SYS), OSX)
-    EIGEN_INCLUDE_PATH = /usr/local/include/eigen3
-  else
-    EIGEN_INCLUDE_PATH = /usr/include/eigen3
-  endif
   ifndef GUIX
     ifdef GUIX_ENVIRONMENT
       GUIX=$(GUIX_ENVIRONMENT)
@@ -93,7 +92,6 @@
   ifdef GUIX
     # Effectively disable paths for GNU Guix
     OPENBLAS_INCLUDE_PATH = .
-    EIGEN_INCLUDE_PATH = $(GUIX)/include/eigen3
     # RPATH = -Xlinker --rpath=$(GUIX)/lib
     ifdef FORCE_STATIC
       LIBS = -L$(GUIX)/lib
@@ -118,7 +116,7 @@
 endif
 
 ifeq ($(CPP), clang++)
-  GCC_FLAGS=-std=c++11 -isystem$(OPENBLAS_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH)
+  GCC_FLAGS=-std=c++11 -isystem$(OPENBLAS_INCLUDE_PATH)
   ifdef GUIX
     CPPFLAGS += -I$(GUIX)/include/c++ -I$(GUIX)/include/c++/x86_64-unknown-linux-gnu
   endif
@@ -139,17 +137,17 @@
 endif
 
 ifneq ($(CXX), clang++)
-  # Clang does not like this switch
-  debug check fast-check: CPPFLAGS += -Og
-endif
-
-debug check fast-check: CPPFLAGS += -g $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+  # Clang does not like these switches
+  debug check fast-check: CPPFLAGS += -Og -Wfatal-errors
+endif
+
+debug check fast-check: CPPFLAGS += -g $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
 
 profile: CPPFLAGS += -pg
 
-release: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
-
-static: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -isystem$(EIGEN_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+release: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
+
+static: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
 
 
 ifeq ($(SYS), WIN)
@@ -165,6 +163,11 @@
 LIBS += -lgsl -lz
 ifdef WITH_OPENBLAS
   LIBS += -lopenblas
+  ifeq ($(SYS), OSX)
+    ifdef WITH_OPENBLAS
+      LIBS += -Wl,-L/usr/local/opt/openblas/lib
+    endif
+  endif
 else
   LIBS += -latlas -lcblas -llapack -lblas
 endif
@@ -173,6 +176,9 @@
 endif
 ifdef WITH_GFORTRAN
   LIBS += -lgfortran -lquadmath
+endif
+ifdef EXTRA_FLAGS
+  LIBS += $(EXTRA_FLAGS)
 endif
 
 .PHONY: all test

## gemma 0.98.4+dfsg

=== debian/changelog ===
gemma (0.98.4+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Apply patch from upstream who explained:
    changed/disabled some other tests (attached).  The problem is that
    different AMD64 CPUs together with OpenBlas simply give different
    results (mostly SIMD differences).
    Closes: #991652

 -- Andreas Tille <tille@debian.org>  Fri, 30 Jul 2021 21:53:57 +0200

gemma (0.98.4+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Follow upstream suggestion to comment some tests that might fail due
    to some floating point rounding
    Closes: #982692

 -- Andreas Tille <tille@debian.org>  Wed, 07 Apr 2021 16:28:38 +0200

gemma (0.98.4+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Do only one test for armhf to reduce test time
    Closes: #985004

 -- Andreas Tille <tille@debian.org>  Mon, 22 Mar 2021 14:09:15 +0100

gemma (0.98.4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Wed, 03 Feb 2021 01:29:26 +0530

gemma (0.98.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    Closes: #952190
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Sat, 28 Nov 2020 23:07:55 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Steffen Moeller <moeller@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                gfortran,
                libopenblas-dev,
                libeigen3-dev,
@@ -11,10 +11,11 @@
                zlib1g-dev,
                catch,
                shunit2
-Standards-Version: 4.2.1
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/gemma
 Vcs-Git: https://salsa.debian.org/med-team/gemma.git
-Homepage: http://www.xzlab.org/software.html
+Homepage: https://www.xzlab.org/software.html
+Rules-Requires-Root: no
 
 Package: gemma
 Architecture: any

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
  https://github.com/genetics-statistics/gemma/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## gemma 0.98.5%2Bdfsg

=== doc/Makefile ===
# A Makefile for generating the PDF from Latex. Simply type 'make' in
# this directory to compile the Latex into a single PDF. Type 'make
# clean' to discard the output files except for the generated PDF.

# RULES
# -----
all: manual.pdf

# Create the PDF file.
manual.pdf : manual.tex manual.bib
	pdflatex manual
	bibtex manual
	pdflatex manual
	pdflatex manual

clean:
	rm -f manual.aux manual.bbl manual.blg
	rm -f manual.log manual.out manual.toc

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,9 @@
                libgsl-dev,
                zlib1g-dev,
                catch,
-               shunit2
-Standards-Version: 4.5.1
+               shunit2,
+               ruby <!nocheck>
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/gemma
 Vcs-Git: https://salsa.debian.org/med-team/gemma.git
 Homepage: https://www.xzlab.org/software.html

## gemma 0.98.5+dfsg

=== Makefile ===
--- 
+++ 
@@ -143,7 +143,7 @@
 
 debug check fast-check: CPPFLAGS += -g $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
 
-profile: CPPFLAGS += -pg
+profile: CPPFLAGS += -g $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
 
 release: CPPFLAGS += -DNDEBUG -O3 $(GCC_FLAGS) $(GSL_INCLUDE_PATH) -Icontrib/catch-1.9.7 -Isrc
 
@@ -181,6 +181,8 @@
   LIBS += $(EXTRA_FLAGS)
 endif
 
+profile: LIBS += -Wl,--no-as-needed -lprofiler -Wl,--as-needed
+
 .PHONY: all test
 
 OUTPUT = $(BIN_DIR)/gemma
@@ -213,7 +215,7 @@
 
 static: $(OUTPUT)
 
-debug: $(OUTPUT)
+debug profile: $(OUTPUT)
 
 ./src/version.h: ./VERSION
 	$(shell bash $(VGEN) $(GUIX_PROFILE) > src/version.h)
@@ -232,23 +234,28 @@
 	./bin/unittests-gemma
 
 fast-check: all unittests
+	rm -vf output/*
+	ruby -Eutf-8 -Itest ./test/dev_tests.rb | tee ./dev_test.log
+
+# Note the following tests are not robust for different architectures
+old-check: all unittests
 	rm -vf test/output/*
-	cd test && ./dev_test_suite.sh | tee ../dev_test.log
-	grep -q 'success rate: 100%' dev_test.log
-
+	cd test && ./dev_test_suite.sh | tee ../test.log
+	grep -q 'success rate: 100%' test.log
+
+# Note the following tests are not robust for different architectures
 slow-check: all
 	rm -vf test/output/*
 	cd test && ./test_suite.sh | tee ../test.log
 	grep -q 'success rate: 100%' test.log
 
+# Note the following tests are not robust for different architectures
 lengthy-check: all
 	rm -vf test/output/*
 	cd test && ./lengthy_test_suite.sh | tee ../lengthy_test.log
 	grep -q 'success rate: 100%' lengthy_test.log
 
-check: fast-check slow-check
-
-check-all: check lengthy-check
+check: fast-check
 
 clean:
 	rm -vf $(SRC_DIR)/*.o

=== debian/changelog ===
gemma (0.98.5+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild against libgsl27

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 17:30:54 +0000

gemma (0.98.5+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Enable hardening
  * Rename autopkgtest script to use a unique name for all our packages
  * Standards-Version: 4.6.0 (routine-update)
  * Build time test is now using ruby

 -- Andreas Tille <tille@debian.org>  Wed, 06 Oct 2021 07:45:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: gemma
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>
 Section: science
 Priority: optional
@@ -12,7 +13,7 @@
                catch,
                shunit2,
                ruby <!nocheck>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/gemma
 Vcs-Git: https://salsa.debian.org/med-team/gemma.git
 Homepage: https://www.xzlab.org/software.html

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 export DH_VERBOSE = 1
 
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/catch -I/usr/include/eigen
 export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -I/usr/include/catch -I/usr/include/eigen

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
  https://github.com/genetics-statistics/gemma/releases .*/v?@ANY_VERSION@@ARCHIVE_EXT@
